# This file is generated automatically. DO NOT EDIT MANUALLY!
# This file combines the contents of:
#     - version.rb
#     - tool.rb
#     - original_bd_pod_extension_net.rb
#     - slardar_assistant.rb
#     - podfile_patch.rb
#     - fix_module.rb

# ----- contents of 'version.rb' -------- 

module BDPodExtentions
  VERSION = '6.4.0'.freeze unless defined? BDPodExtentions::VERSION
end


# ----- contents of 'tool.rb' -------- 


module BD

    module Tool
  
      def self.show_as_notification(title="", content)
        system ("osascript -e 'display notification \"#{content}\" with title \"#{title}\" '")
      end
  

      class Path
  
        def self.config
          @config ||= Pod::Config.new
          @config
        end
  
        # [Pathname] the path that contain podfile
        def self.podfile_root_path
          @podfile_root_path ||= config.installation_root
          @podfile_root_path  
        end
      end

    end
end


module BD

    # provide a base class that have a podfile variable
    class PodfileEnvironment
  
      attr_accessor :podfile
  
      def initialize(podfile)
        self.podfile = podfile
      end
  
    end
end

# ----- contents of 'original_bd_pod_extension_net.rb' -------- 

# Created by Wusizhen on 3/15/18.
# Copyright (c) 2018 Bytedance. All rights reserved.

#!/usr/bin/env ruby
#!/usr/bin/ruby
# -*- coding: UTF-8 -*-
# encoding: utf-8
require "bd_pod_extentions/version"
require 'xcodeproj'
require 'cocoapods'
require 'rubygems'
require 'json'
require 'pp'
require 'open-uri'
require 'net/http'
BEGIN {
  def get_response(url)
    begin
      url_str = URI.parse(url)
      callObject =  Net::HTTP.get_response(url_str)
      yield callObject
    rescue Exception => ex
      p ex
    end
  end

  def loadDev
    if File::exist?('Podfile_Dev')
      $Loaded_dev = true
    end
  end


  swiftSpeed = 'http://tosv.byted.org/obj/iosbinary/bd_pod_extentions/6.3.0/swift_spped.rb'
  get_response(swiftSpeed) do |swiftSpeed_response|
    if swiftSpeed_response.code == '200'
      lastDir = Dir::pwd
      $work_dir = Dir.home() + '/.bd_pod_extension_scripts'
      Pathname.new($work_dir).mkdir unless File::directory?($work_dir)
      aFile = File.new("#{$work_dir}/swift_spped.rb", "a+")
      if aFile
        aFile.syswrite(swiftSpeed_response.body)
      end
    end
  end

  ocSpeed = 'http://tosv.byted.org/obj/iosbinary/bd_pod_extentions/6.3.0/oc_spped.rb'
  get_response(ocSpeed) do |ocSpeed_response|
    if ocSpeed_response.code == '200'
      lastDir = Dir::pwd
      $work_dir = Dir.home() + '/.bd_pod_extension_scripts'
      Pathname.new($work_dir).mkdir unless File::directory?($work_dir)
      aFile = File.new("#{$work_dir}/oc_spped.rb", "a+")
      if aFile
        aFile.syswrite(ocSpeed_response.body)
      end
    end
  end



  confuse_handle = 'http://tosv.byted.org/obj/iosbinary/bd_pod_extentions/6.3.0/confuse_handle.rb'
  get_response(confuse_handle) do |confuse_handle_response|
    if confuse_handle_response.code == '200'
      lastDir = Dir::pwd
      $work_dir = Dir.home() + '/.bd_pod_extension_scripts'
      Pathname.new($work_dir).mkdir unless File::directory?($work_dir)
      aFile = File.new("#{$work_dir}/confuse_handle.rb", "a+")
      if aFile
        aFile.syswrite(confuse_handle_response.body)
        $LOAD_PATH << "#{$work_dir}"
        load 'confuse_handle.rb'
      end
    end
  end


  transform = 'http://tosv.byted.org/obj/iosbinary/bd_pod_extentions/6.3.0/BDTransmit'
  get_response(transform) do |transform_handle_response|
    if transform_handle_response.code == '200'
      lastDir = Dir::pwd
      $work_dir = Dir.home() + '/.bd_pod_extension_scripts'
      Pathname.new($work_dir).mkdir unless File::directory?($work_dir)

      system("rm -rf #{$work_dir}/BDTransmit")
      aFile = File.new("#{$work_dir}/BDTransmit", "a+")
      if aFile
        aFile.syswrite(transform_handle_response.body)
        system("chmod 777 #{$work_dir}/BDTransmit")
      end

      $work_dir = Dir.home() + '/.bd_pod_extension_scripts'

    end
  end

  uuid = 'http://tosv.byted.org/obj/iosbinary/bd_pod_extentions/6.3.0/GetDerivedDataUUID'
  get_response(uuid) do |transform_handle_response|
    if transform_handle_response.code == '200'
      lastDir = Dir::pwd
      $work_dir = Dir.home() + '/.bd_pod_extension_scripts'
      Pathname.new($work_dir).mkdir unless File::directory?($work_dir)

      system("rm -rf #{$work_dir}/GetDerivedDataUUID")
      aFile = File.new("#{$work_dir}/GetDerivedDataUUID", "a+")
      if aFile
        aFile.syswrite(transform_handle_response.body)
        system("chmod 777 #{$work_dir}/GetDerivedDataUUID")
      end

      $work_dir = Dir.home() + '/.bd_pod_extension_scripts'

    end
  end

  frameworkContainerUri = 'http://tosv.byted.org/obj/staticanalysisresult/ios_frameworks.json'
  get_response(frameworkContainerUri) do |html_response_framework|
    PODS = JSON.parse(html_response_framework.body)
  end


  SourceContainerUri = 'http://tosv.byted.org/obj/iosbinary/sourcecontainer.framework.json'
  get_response(SourceContainerUri) do |html_response_source|
    SourceContainer = JSON.parse(html_response_source.body)
  end

  deprecatedContainerUri = 'https://ios.bytedance.net/wlapi/deprecatedInfo/'
  get_response(deprecatedContainerUri) do |html_response_deprecated|
    Deprecated = JSON.parse(html_response_deprecated.body)
    realTime = Deprecated['archRealTime']
    if !realTime
      Now = Time.new.to_i
    else
      Now = realTime
    end
  end

  $NEEDBINARY = 0
  $NEEDSOURCE = 0
  $LOADEDBINARYSOURCE = 0
  $Toutiao = "13"
  $Douyin = "1128"
  $Wenda = "1165"
  $CurrentApp = $Toutiao
  $NEEDSPEED = 0
  
  $Debug_Record = Hash.new

  CurrentPodfilePath = Dir.pwd
  WarningModules = Array.new
  Binary = Array.new

  DevPods = Array.new
  Target_Dev_Pods_Map = Hash.new
  $CurrentDevPodsMap = nil

  EachDevPods = Array.new
  Target_Dev_Pod_Container = Hash.new
  $CurrentDevPods = nil
  $Bd_enable_DevelopMode


  $Loaded_dev = false
  loadDev

  $Confuse_Enable = false
  $Confuse_Pods = Array.new

  $BD_used = false
  $BD_ignore = 'none'

  $ShowCode_Enable = false
}

def showCode!
  $ShowCode_Enable = true
end


def bd_awesome_func(text)
  system ("osascript -e 'display notification \"废弃理由:#{text},\n 组件废弃时间:#{text} \" with title \"#{text}-#{text} 被废弃\" subtitle \"操作人:#{text}\" '")

end

def startSpeed()
  $NEEDSPEED = 1
  $work_dir = Dir.home() + '/.bd_pod_extension_scripts'
  $LOAD_PATH << "#{$work_dir}"
  load "oc_spped.rb"
end

def removeDependencyVersion()
  $work_dir = Dir.home() + '/.bd_pod_extension_scripts'
  load "#{$work_dir}/swift_spped.rb"
end

def target_patch(name,options = nil)
  DevPods.clear
  yield if block_given?
  Target_Dev_Pods_Map[name] = DevPods.dup
  Target_Dev_Pod_Container[name] = EachDevPods.dup
end

def pod_dev(moduleName,*requirements)
  DevPods << {moduleName => requirements}
  EachDevPods << moduleName
end

def bd_enable_DevelopMode
  if File::exist?('Podfile_Patch')
    $Bd_enable_DevelopMode = true
    load 'Podfile_Patch'
  end
end

def get_fetch(url)
  begin
    url_str = URI.parse(url)
    return Net::HTTP.get_response(url_str)
  rescue Exception => ex
    p ex
  end
end

def bd_fetch(tag)
  component = get_fetch('http://tosv.byted.org/obj/iosbinary/component_test.json')
  $AllInfo = JSON.parse(component.body)
  raise "标签不相符" unless $AllInfo['uuid'] == tag
  createProject
end

def createProject
  $AllInfo['projects'].each do |project|
    target project['name'] do
      project['components'].each do |podInfo|
        value = adaptPodinfoToHashArray(podInfo)
        if podInfo['version']

          case value.size
          when 0
            pod_binary podInfo['name'],podInfo['version']
          when 1
            pod_binary podInfo['name'],podInfo['version'],value[0]
          when 2
            pod_binary podInfo['name'],podInfo['version'],value[0],value[1]
          when 3
            pod_binary podInfo['name'],podInfo['version'],value[0],value[1],value[2]
          when 4
            pod_binary podInfo['name'],podInfo['version'],value[0],value[1],value[2],value[3]
          end
        end
      end
    end
  end
end

def adaptPodinfoToHashArray(podInfo)
  argsment = Array.new()
  podInfo.each do |key,value|
    if key != 'name' && key != 'version'
      argsment << Hash[key.to_sym => value]
    end
  end
  argsment
end

def pod_install_dev
  if $CurrentDevPodsMap
    $CurrentDevPodsMap.each do |hash|
      hash.each { |key,value|
        case value.size
        when 0
          pod key
        when 1
          pod key,value[0]
        when 2
          pod key,value[0],value[1]
        when 3
          pod key,value[0],value[1],value[2]
        when 4
          pod key,value[0],value[1],value[2],value[3]
        end
      }
    end
  end
end

def bytedanceRemoveAllConfuse
  $Confuse_Enable = true
end

def bytedanceAnalyzeSpeed(enable=true,type = {:project_type => 'objective-c'})
  if enable
    if type[:project_type] == 'swift'
      removeDependencyVersion
    elsif type[:project_type] == 'objective-c'
      startSpeed
    end

  end
end

def bd_use_app (*appName)
  plugin 'cocoapods-bytedance-transform'
  plugin 'cocoapods-bytedance-Slardar'
  plugin 'cocoapods-bytedance-PlatformRecord'
  plugin 'cocoapods-bytedance-DebugBinary'
  $BD_used = true
  $Apps = Array.new
  for app in 0...appName.length
    each_bd_use_app(appName[app])
  end
end

def each_bd_use_app(appName="toutiao")
  apps = SourceContainer["apps"]
  $CurrentApp = apps["#{appName}"]
  $Apps << $CurrentApp
  allsource = SourceContainer["source"]
  placehold = apps["#{appName}"]
  currentSourceContainer = allsource["#{placehold}"]
  if currentSourceContainer
    currentSourceContainer.each do |eachSource|
      next if $BD_ignore == 'binary' && eachSource.include?("_binary_repo.git")
      next if $BD_ignore == 'source' && eachSource.include?("_source_repo.git")
      source eachSource;
    end
  else
    source 'git@code.byted.org:iOS_Library/toutiao_binary_repo.git'
    source 'git@code.byted.org:iOS_Library/toutiao_source_repo.git'
    source 'git@code.byted.org:TTIOS/cocoapods-master-specs-mirror.git'
    source 'git@code.byted.org:TTVideo/ttvideo-pods.git'
    source 'git@code.byted.org:ugc/UGCSpecs.git'
  end
end

def bd_use_source!()
  $BD_used = true
  raise "You have already setted bd_use_binary! or bd_ignore_source!" unless $NEEDBINARY != 1
  $NEEDSOURCE = 1
end

def bd_use_binary!()
  $BD_used = true
  raise "You have already setted bd_use_source! or bd_ignore_binary!" unless $NEEDSOURCE != 1
  $NEEDBINARY = 1
end

def bd_ignore_binary!()
  raise "You should set bd_ignore_binary! before bd_use_binary! 、 bd_use_source!、bd_use_app" if $BD_used
  $BD_ignore = 'binary'
  bd_use_source!
end

def bd_ignore_source!()
  raise "You should set bd_ignore_source! before bd_use_binary! 、 and bd_use_source!、bd_use_app" if $BD_used
  $BD_ignore = 'source'
  bd_use_binary!
end

def bd_source(url)
  if $LOADEDBINARYSOURCE == 0
    source 'git@code.byted.org:wusizhen.arch/ios_frameworks.git'
    $LOADEDBINARYSOURCE = 1
  end
  source url
end

def show_deprecated(moduleName,deprecated)
  deprecated_time = Time.at deprecated['deTime']
  operate_time = Time.at deprecated['opTime']
  user = deprecated['username']
  version = deprecated['version']
  des = deprecated['des']
  level = deprecated['level']
  case level
  when 'error'
    if Now > deprecated_time.to_i
      system ("osascript -e 'display notification \"废弃理由:#{des},\n 组件废弃时间:#{deprecated_time.inspect} \" with title \"#{moduleName}-#{version} 被废弃\" subtitle \"操作人:#{user}\" '")
      raise "#{moduleName} - #{version} 被废弃,原因为:#{des},操作人:#{user},组件废弃时间:#{deprecated_time.inspect},操作废弃时间:#{operate_time.inspect}"
    end

  when 'warning'
    if Now > deprecated_time.to_i
      system ("osascript -e 'display notification \"废弃理由:#{des},\n 组件废弃时间:#{deprecated_time.inspect} \" with title \"#{moduleName}-#{version} 被废弃\" subtitle \"操作人:#{user}\" '")
      raise "#{moduleName} - #{version} 被废弃,原因为:#{des},操作人:#{user},组件废弃时间:#{deprecated_time.inspect}"
    end
    system ("osascript -e 'display notification \"废弃理由:#{des},\n 组件废弃时间:#{deprecated_time.inspect} \" with title \"#{moduleName}-#{version} 被废弃\" subtitle \"操作人:#{user}\" '")
    puts "#{colorize("===============================================================================","red")}"
    puts "#{colorize("#{moduleName} 将于 #{deprecated_time.inspect} 废弃，废弃理由:#{des},操作人:#{user}","red")}"
    puts "#{colorize("===============================================================================","red")}"
  end


end

def pod_binary(moduleName,version=-1,args2=-1,args3=-1,args4=-1)
  argsment = rebuild_pod(version,args2,args3,args4,moduleName)
  if $NEEDSOURCE == 1
    common_pod_command(moduleName,argsment,-1)
  else
    common_pod_command(moduleName,argsment,1)
  end
end

def pod_source(moduleName,version=-1,args2=-1,args3=-1,args4=-1)
  argsment = rebuild_pod(version,args2,args3,args4,moduleName)
  if $NEEDBINARY == 1
    common_pod_command(moduleName,argsment,1)
  else
    common_pod_command(moduleName,argsment,-1)
  end
end

def subspecHandle(moduleName, argsment)
  if moduleName.include?"/"
    subspecArray = moduleName.split("/")
    subspecArray.delete_at(0)
    newsubspecs = subspecArray.join("/")
    if containSubspecComponent(argsment)
      argsment.each do |subspec|
        if subspec.class == Hash
          if subspec.keys.include?(:subspecs)
            subspec[:subspecs] = subspec[:subspecs].map { |e|
              newsubspecs + "/" + e
            }
          end
        end
      end
      return [moduleName.split("/")[0], argsment]
    else
      if argsment.empty?
        argsment = Hash.new
        argsment[:subspecs] = [newsubspecs]
        return [moduleName.split("/")[0], [argsment]]
      end
      subspecComponent = Hash.new
      subspecComponent[:subspecs] = [newsubspecs]
      argsment << subspecComponent
      return [moduleName.split("/")[0], argsment]
    end
  end
  [moduleName, argsment]
end

def containSubspecComponent(argsment)
  if !argsment.empty?
    argsment.each do |subspec|
      if subspec.class == Hash
        if subspec.keys.include?(:subspecs)
          return true
        end
      end
    end
  end
  return false
end


def common_pod_command(moduleName,argsment,binary=1)
  if $CurrentDevPods
    return unless !$CurrentDevPods.include?(moduleName)
  end
  moduleName,argsment = subspecHandle(moduleName,argsment)
  if argsment.empty?
    puts "#{colorize("===============================================================================","purple")}"
    puts "#{colorize("#{moduleName} undefined the exact version","purple")}"
    puts "#{colorize("===============================================================================","purple")}"
    bd_platform_pod moduleName
  else
    versionTemparray = argsment.reject{ |item|
      item.class != String || item == -1
    }
    newarray = argsment.reject { |item|
      item.class == String || item == -1
    }

    if versionTemparray.empty?
      if newarray.length == 0
        puts "#{colorize("===============================================================================","purple")}"
        puts "#{colorize("#{moduleName} undefined the exact version","purple")}"
        puts "#{colorize("===============================================================================","purple")}"
        bd_platform_pod moduleName
      elsif newarray.length == 1
        bd_platform_pod moduleName,newarray[0]
      elsif newarray.length == 2
        bd_platform_pod moduleName,newarray[0],newarray[1]
      elsif newarray.length == 3
        bd_platform_pod moduleName,newarray[0],newarray[1],newarray[2]
      elsif newarray.length == 4
        bd_platform_pod moduleName,newarray[0],newarray[1],newarray[2],newarray[3]
      end
    else
      if newarray.empty?
        bd_platform_pod moduleName,pod_binary_version_check(moduleName,versionTemparray[0],binary)
      elsif newarray.length == 1
        bd_platform_pod moduleName,pod_binary_version_check(moduleName,versionTemparray[0],binary),newarray[0]
      elsif newarray.length == 2
        bd_platform_pod moduleName,pod_binary_version_check(moduleName,versionTemparray[0],binary),newarray[0],newarray[1]
      elsif newarray.length == 3
        bd_platform_pod moduleName,pod_binary_version_check(moduleName,versionTemparray[0],binary),newarray[0],newarray[1],newarray[2]
      elsif newarray.length == 4
        bd_platform_pod moduleName,pod_binary_version_check(moduleName,versionTemparray[0],binary),newarray[0],newarray[1],newarray[2],newarray[3]
      end
    end
  end

end

def rebuild_pod(version=-1,args2=-1,args3=-1,args4=-1,moduleName)
  argsment=Array[version,args2,args3,args4]
  return argsment.uniq.reject{ |item|
    if item.class == Hash
      if item.key?(:confuse)
        $Confuse_Pods << moduleName unless $Confuse_Pods.include?(moduleName)
        item.key?(:confuse)
      end
    else
      item == -1
    end
  }
end

def pod_binary_version_check(moduleName,version,needcheck=-1)
  deprecatedVersions = getDeprecatedContainerByApp($Apps,moduleName)
  if deprecatedVersions
    deprecatedVersions.each do |deprecated|
      if deprecated["version"] == version
        show_deprecated(moduleName,deprecated)
      end
    end
  end
  if needcheck == -1
    return version
  end
  if version.class == Hash
    if (version.keys.include?(:path)) ||  (version.keys.include?(:git))
      return version
    end
  end
  currentModuleVersions = getBinaryContainerByApp($Apps,moduleName)
  if !currentModuleVersions
    return version
  end
  if version.include?"-"
    if currentModuleVersions.include?("#{version}.1.binary")
      recordBinaryPods(moduleName)
      return "#{version}.1.binary"
    end
    if currentModuleVersions.include?("#{version}.1-binary")
      recordBinaryPods(moduleName)
      return "#{version}.1-binary"
    end
  else
    if currentModuleVersions.include?("#{version}.1-binary")
      recordBinaryPods(moduleName)
      return "#{version}.1-binary"
    end
  end

  if currentModuleVersions.include?(version)
    if WarningModules.include?(moduleName)
      return version
    end
    WarningModules << moduleName
    puts "#{colorize("===============================================================================","light red")}"
    puts "#{colorize("Binary Warning:You should not use binary version directly for #{moduleName}","light red")}"
    puts "#{colorize("===============================================================================","light red")}"
    recordBinaryPods(moduleName)
    return version
  end
  if WarningModules.include?(moduleName)
    return version
  end
  WarningModules << moduleName

  puts "#{colorize("===============================================================================","red")}"
  puts "#{colorize("#{moduleName} Binary Warning:Current version:#{version} have no binary version","red")}"
  puts "#{colorize("===============================================================================","red")}"
  return version
end

def recordBinaryPods(moduleName)
  Binary << moduleName;
end

def getDeprecatedContainerByApp(apps=["13"],moduleName)
  raise '不应该在Podfile_Patch使用pod_source or pod_binary' if !apps && $Bd_enable_DevelopMode
  versions = Array.new
  apps.each do |app|
    currentAppVersions = getEachDeprecatedContainerByApp(app,moduleName)
    if currentAppVersions
      versions = versions | currentAppVersions
    end
  end
  return versions
end

def getEachDeprecatedContainerByApp(appName="13",moduleName)

  currentAppBinaryContainer = Deprecated["#{appName}"]

  if !currentAppBinaryContainer
    return nil
  end
  currentModuleVersions = currentAppBinaryContainer["#{moduleName}"]

  return currentModuleVersions;
end

def getBinaryContainerByApp(apps=["13"],moduleName)
  versions = Array.new
  apps.each do |app|
    currentAppVersions = getEachBinaryContainerByApp(app,moduleName)
    if currentAppVersions
      versions = versions | currentAppVersions
    end
  end
  return versions
end

def getEachBinaryContainerByApp(appName="13",moduleName)

  currentAppBinaryContainer = PODS["#{appName}"]

  if !currentAppBinaryContainer
    return nil
  end
  currentModuleVersions = currentAppBinaryContainer["#{moduleName}"]

  if !currentModuleVersions

    currentModuleVersions = PODS["#{moduleName}"]
  end

  return currentModuleVersions;
end

def colorize(text, color = "default", bgColor = "default")
  colors = {"default" => "38","black" => "30","red" => "31","green" => "32","brown" => "33", "blue" => "34", "purple" => "35",
            "cyan" => "36", "gray" => "37", "dark gray" => "1;30", "light red" => "1;31", "light green" => "1;32", "yellow" => "1;33",
            "light blue" => "1;34", "light purple" => "1;35", "light cyan" => "1;36", "white" => "1;37"}
  bgColors = {"default" => "0", "black" => "40", "red" => "41", "green" => "42", "brown" => "43", "blue" => "44",
              "purple" => "45", "cyan" => "46", "gray" => "47", "dark gray" => "100", "light red" => "101", "light green" => "102",
              "yellow" => "103", "light blue" => "104", "light purple" => "105", "light cyan" => "106", "white" => "107"}
  color_code = colors[color]
  bgColor_code = bgColors[bgColor]
  return "\033[#{bgColor_code};#{color_code}m#{text}\033[0m"
end

module Pod
  class Installer
    def ensure_plugins_are_installed!
      require 'claide/command/plugin_manager'

      loaded_plugins = Command::PluginManager.specifications.map(&:name)

      podfile.plugins.keys.each do |plugin|
        unless loaded_plugins.include? plugin
          raise Informative, "Your Podfile requires that the plugin `#{plugin}` be installed. Please install it and try installation again." unless plugin.include?('cocoapods-bytedance-')
        end
      end
    end
  end
end


Pod::HooksManager.register('cocoapods-bytedance-transform', :post_install) do |installer_context|

  Dir.chdir(File::dirname(installer_context.sandbox_root)) do
    cdir = File.dirname(__FILE__)
    if !Binary.empty? && !ENV['WORKSPACE']

      string = Binary.to_s
      string = string.gsub("\"","").gsub("[","").gsub("]","").gsub(","," ")
      system("#{cdir}/BDTransmit #{string} #{CurrentPodfilePath}")
    end
  end
end



Pod::HooksManager.register('cocoapods-bytedance-PlatformRecord', :post_install) do |installer_context|

  if ENV['WORKSPACE'] || ENV.has_key?('CI_JOB_NAME')

    sandbox_root = File::dirname(installer_context.sandbox_root)
    Dir.chdir(sandbox_root) do
      if File::exist?(File.dirname(__FILE__)+'/bd_pod_extentions/version')
        require File.dirname(__FILE__)+'/bd_pod_extentions/version'
      else
        require "bd_pod_extentions/version"
      end

      cmd = "
    curl -o ParseLock http://tosv.byted.org/obj/iosbinary/bd_pod_extentions/#{BDPodExtentions::VERSION}/ParseLock
    chmod 777 ParseLock
    curl -o generatorResult.js http://tosv.byted.org/obj/iosbinary/bd_pod_extentions/6.3.0/generatorResult.js
    ./ParseLock vjson Podfile.lock
    branch=`git symbolic-ref --short -q HEAD`
    commit=`git rev-parse HEAD`
    git=`git remote -v |xargs -n 1|egrep 'git' |head -n 1`
    curl -s -o node_modules.zip http://tosv.byted.org/obj/iosbinary/platform/node_modules.zip
    unzip node_modules.zip
    node generatorResult.js version.json $commit $git $branch
    curl -X POST \
    https://ios.bytedance.net/wlapi/onLineVersion \
      -H 'Content-Type: application/json' \
      -d \"{ \
        \\\"pods\\\":`cat version.json`,\
        \\\"commitid\\\" : \\\"$commit\\\",\
        \\\"branch\\\" : \\\"$branch\\\",\
        \\\"gitAddress\\\" : \\\"$git\\\",\
        \\\"JOB_URL\\\" : \\\"$JOB_URL\\\"\
      }\"
    "
      system(cmd)
    end

  end


end

Pod::HooksManager.register('cocoapods-bytedance-DebugBinary', :post_install) do |installer_context|

  if !ENV['WORKSPACE']

    json = $Debug_Record.to_json
    aFile = File.new("#{installer_context.sandbox_root}/pod.json", "w+")
    if aFile
      aFile.syswrite(json)
    end
    cdir = File.dirname(__FILE__)
    cmd = "
    IFS=$\n
    cd \"#{installer_context.sandbox_root}\"
    cd ..
    cd *.xcworkspace
    cdir=`pwd`
    uuid=`#{cdir}/GetDerivedDataUUID \"$cdir\"`
    test ! -d \"$HOME\"/Library/Developer/Xcode/DerivedData/*-$uuid && cd \"$HOME\"/Library/Developer/Xcode/DerivedData && mkdir \"$uuid-$uuid\"
    cd \"$HOME\"/Library/Developer/Xcode/DerivedData/*-$uuid
    cp \"#{installer_context.sandbox_root}/pod.json\" `pwd`
    "
    system(cmd)
  end
end



module Pod
  class Podfile
    module DSL
      def target(name, options = nil)

        if options
          raise Informative, "Unsupported options `#{options}` for " \
            "target `#{name}`."
        end
        parent = current_target_definition
        definition = TargetDefinition.new(name, parent)
        self.current_target_definition = definition
        $CurrentDevPodsMap = Target_Dev_Pods_Map[name]
        $CurrentDevPods = Target_Dev_Pod_Container[name]
        pod_install_dev
        yield if block_given?
      ensure
        self.current_target_definition = parent
      end



      alias bd_platform_pod pod

      def pod(name = nil, *requirements)
        if requirements.size != 0
          version = requirements[0]
          if version.class != Hash
            if version.include?("1-binary")||version.include?("1.binary")
              Binary << name
            end
          end
        end
        bd_platform_pod(name,*requirements)
      end

    end
  end

end


# ----- contents of 'slardar_assistant.rb' -------- 

BEGIN {
  # key: [String] pod name
  # value: [Hash] git address and commit/tag/...
  $pods_git_source = {}
}



module Pod
  class Specification

    # hook method to record pod git sources
    #
    old_root = instance_method(:root)
    define_method(:root) do
      result = old_root.bind(self).()
      bd_record_source
      return result
    end

    private
    def bd_record_source

      if !$pods_git_source[attributes_hash['name']]

        source = attributes_hash['source'] #获取source的数据源
        if source
          unless source.keys.include?('git')
            source = attributes_hash['source_code']# 如果获取不到source的数据源就尝试获取source_code中记录的，这里不能支持官方的zip源
            debug_source = attributes_hash['source'] # 记录zip地址用于转化
          end

        end
        source = attributes_hash['source_code'] if !source # 兜底方案，如果没有source的话尝试取source_code

        $pods_git_source[attributes_hash['name']] = source if source
        $Debug_Record[attributes_hash['name']] = debug_source if debug_source
      end

    end

  end
end




Pod::HooksManager.register('cocoapods-bytedance-Slardar', :post_install) do |installer_context|

  if ENV['WORKSPACE'] || ENV.has_key?('CI_JOB_NAME')

    pods_git_source = $pods_git_source

    # After pod install, the manifest file is the same with podfilelock
    lockfile = Pod::Lockfile.from_file(installer_context.sandbox.manifest_path)
    checkout_data = lockfile.send :checkout_options_data
    checkout_data.each do |pod_name, hash|
      pods_git_source[pod_name] = hash
    end

    # write to file
    sandbox_root = File.dirname(installer_context.sandbox_root)
    filename = "pod.json"
    File.write(Pathname.new(sandbox_root) + filename, pods_git_source.to_json)

    cmd = "
    root=`git rev-parse --show-toplevel`
    cd $root
    curl -o ParseProjectFileMap http://tosv.byted.org/obj/iosbinary/bd_pod_extentions/#{BDPodExtentions::VERSION}/ParseProjectFileMap
    chmod 777 ParseProjectFileMap
    find ./ -type f|egrep -v \".svn|.git|.png|.plist|.strings|vendor/bundle\" > context.txt
    commit=`git rev-parse HEAD`
    git=`git remote -v |xargs -n 1|egrep 'git' |head -n 1`
    ./ParseProjectFileMap $root/context.txt #{sandbox_root}/#{filename} $git $commit
    if [[ $? -ne 0 ]]; then
      curl -X GET -G --data-urlencode \"text=$git\" --data-urlencode \"username=wusizhen.arch\" \"https://ios.bytedance.net/wlapi/sendMessage\"
      fi
      "
    system(cmd)
  end

end


# ----- contents of 'podfile_patch.rb' -------- 


# modified from https://code.byted.org/iOS_Library/cocoapods-podfile_patch

require 'cocoapods-core/specification'
require 'cocoapods-core/podfile'
require 'pathname'
require 'set'


module Pod
    class Podfile
      module DSL
  
        # podfile patch feature
        # 
        # MUST be used with `bd_use_patch_file_end!` together.
        #
        # call `bd_use_patch_file_begin!` before pods configuration
        # call `bd_use_patch_file_end!` at the very end of podfile
        #
        # More info at https://code.byted.org/iOS_Library/cocoapods-podfile_patch
        #
        def bd_use_patch_file_begin!(patchfile_path = "Podfile.patch")
            @bd_current_patch_files ||= []
            if @bd_current_patch_files.include? patchfile_path
                # Yes, you could even use it recureively, but don't use the same patch file.
                raise "`use_patch_file!` called recursively. Most case is it's used in Patch file."
                return 
            end
            
            @bd_current_patch_files << patchfile_path
            require 'cocoapods-podfile_patch/podfile_patch'
            @bd_current_patch_target = BD::PodfilePatch.new.load_patch_target self, patchfile_path
            @bd_current_patch_files.delete(patchfile_path)
        end

        # call it at the very end of podfile
        def bd_use_patch_file_end!
            if not @bd_current_patch_target.nil?
                BD::PodfilePatch.new.merge_patch_and_original_podfile(self, @bd_current_patch_target)
            end
        end

      end
    end
end

module BD
    class PodfilePatch

        ABSTRACT_PATCH_TARGET_NAME = "#{self}-fake-target"

        def load_patch_target(podfile, patchfile_path)

            # find patch file
            patch_file_path = Pathname.new(patchfile_path)
            if not patch_file_path.expand_path.file? 
                podfile_root_path = Pathname.new(podfile.defined_in_file).dirname
                patch_file_path = (podfile_root_path + patch_file_path).expand_path
            end
            if not patch_file_path.file?
                Pod::UI.info "Podfile patch feature is enabled. (No patch file now.)"
                return  
            end
            
            # load patch file content. And add it to a abstract target
            contents = File.read(patch_file_path)
            podfile.target ABSTRACT_PATCH_TARGET_NAME do
                podfile.instance_eval contents
            end

            # find the patch target and delete it in original podfile
            root_target = podfile.root_target_definitions[0]
            patch_target = root_target.children.find {|t| t.name == ABSTRACT_PATCH_TARGET_NAME }
            root_target.children.delete(patch_target)

            return patch_target
        end
        

        def merge_patch_and_original_podfile(podfile, patch_target)
            
            root_target = podfile.root_target_definitions[0]
            
            # merge patch_target and original_target
            patch_target.name = root_target.name
            merge_target_definitions_dependency(root_target,  patch_target)

            Pod::UI.titled_section "Podfile patch feature is enabled" do
                next unless Pod::UI.config.verbose?
                Pod::UI.section "Patchfile Info" do 
                    self.print_podfile_raw_dependencies patch_target
                end
                Pod::UI.section "Modified Podfile Info" do 
                    self.print_podfile_raw_dependencies root_target
                end
            end
        end


        def merge_target_definitions_dependency(targetdef, patch_targetdef)
            # Demo Data
            # Original Target
            # ```
            # TargetDefination 'Pods':
            # [{"BDWebImage"=>["1.0.1.1-binary"]}]
            #
            #     TargetDefination 'Pods-FrameworkDemos_Tests':
            #     ["BDWebImage/SDAdapter", "BDWebImage/Download", {"TTNetworkManager"=>["2.2.8.46-rc.18"]}, {"AFNetworking"=>[{:path=>"/Users/lea/Downloads/AFNetworking"}]}]
            #   
            #     TargetDefination 'Pods-FrameworkDemos_Example':
            #     ["BDWebImage", {"TTNetworkManager"=>["2.2.8.46-rc.18"]}]
            # ```
            #
            # Patch Target
            # ```
            # TargetDefination 'Pods':
            # [{"AFNetworking"=>["2.3"]}]
            # ```

            # 1. find all dependency patch_targetdef: patched_dependencies
            # 2. modify targetdef's depedencies recursively:
            #       - replace the requirement to the one in patched_dependencies 
            #       - add to target if not contained


            def get_raw_dependencies(target_defination)
                (target_defination.send :get_hash_value, 'dependencies') || []
            end

            all_dependencies_in_patch = begin
                def all_dependencies(target_defination)
                    d = get_raw_dependencies(target_defination) 
                    d += (target_defination.children.map do |subtarget|
                        all_dependencies(subtarget)
                    end.flatten || [])
                    d
                end
                all_dependencies(patch_targetdef)
            end
            
            def transform_target_dependency_to_dict(dependencies)
                dict = {}
                dependencies.each do |name_or_hash|
                    if name_or_hash.is_a?(Hash)
                        name = name_or_hash.keys.first
                        requirements = name_or_hash.values.first
                        dict[name] = requirements
                    else
                        dict[name_or_hash] = {}
                    end
                end
                dict
            end

            dependencies_dict_in_patch = transform_target_dependency_to_dict(all_dependencies_in_patch)

            def modify_target_defination_recursively(target_defination, &block)
                block.call(target_defination)
                target_defination.children.each { |t| modify_target_defination_recursively(t, &block) }
            end

            patch_file_all_targets_dict = begin
                targets = {}
                modify_target_defination_recursively(patch_targetdef) do |t|
                    targets[t.name] = t
                end
                targets
            end

            patch_file_target_to_dependency_dict = begin
                dict = {}
                modify_target_defination_recursively(patch_targetdef) do |t|
                    deps = get_raw_dependencies(t)
                    dict[t.name] = transform_target_dependency_to_dict(deps)
                end
                dict
            end

            modified_dependencies_names = {} # pod name => target name

            modify_target_defination_recursively(targetdef) do |t|
                deps = get_raw_dependencies(t)
                new_deps = []
                deps_set = Set.new
                
                # modify origianl dependency
                deps.each do |name_or_hash|
                    name = nil
                    if name_or_hash.is_a?(Hash)
                        name = name_or_hash.keys.first
                    else
                        name = name_or_hash
                    end
                    if dependencies_dict_in_patch.key? name
                        new_deps << {name => dependencies_dict_in_patch[name]}
                        modified_dependencies_names[name] = t
                    else
                        new_deps << name_or_hash
                    end
                    deps_set.add(name)
                end
                # add new dependency
                patching_deps = patch_file_target_to_dependency_dict[t.name]
                if not patching_deps.blank?
                    patching_deps.each do |name, requirements|
                        if not deps_set.include? name
                            new_deps << (requirements.empty? ? name : {name => requirements})
                            modified_dependencies_names[name] = t
                        end
                    end
                end

                t.send :set_hash_value, "dependencies", new_deps
            end

            # handle MODULAR_HEADERS & INHIBIT_WARNING
            [ 'inhibit_warnings',
            'use_modular_headers'].each do |method|
                modify_target_defination_recursively(targetdef) do |t|
                    original_inhibit_warning_dict = t.send(:get_hash_value,method, {})
                    original_inhibit_warning_dict.each do |key, value|
                        # the key is "for_pods" or "not_for_pods" or "all"
                        # Clear if patchfile have modified the pod
                        next unless value.kind_of? Array
                        value.reject! { |name| modified_dependencies_names.include? name}
                    end
        
                    patch_target = patch_file_all_targets_dict[t.name]
                    if not patch_target.nil?
                        patch_inhibit_warning_dict = patch_target.send(:get_hash_value,method, {})
                        patch_inhibit_warning_dict.each do |key, value|
                            if value.kind_of? Array
                                original = original_inhibit_warning_dict[key] || []
                                original.concat(value).uniq! 
                                original_inhibit_warning_dict[key] = original
                            elsif [true, false].include? value # "all"
                                original_inhibit_warning_dict[key] = value
                            end
                        end
                    end
                    # delete key if blank
                    if original_inhibit_warning_dict.empty?
                        t.send(:internal_hash).delete(method)
                    end
                end
            end

            # handle CONFIGURATION_WHITELIST
            modify_target_defination_recursively(targetdef) do |t|
                key = "configuration_pod_whitelist"
                original = t.send :get_hash_value, key, {}
                original.each do |config_name, pods|
                    # Clear if patchfile have modified the pod
                    next unless pods.kind_of? Array
                    pods.reject! { |name| modified_dependencies_names.include? name}
                end
                
                patch_target = patch_file_all_targets_dict[t.name]
                if not patch_target.nil?
                    patched = patch_target.send :raw_configuration_pod_whitelist
                    patched.each do |config_name, pods|
                        next unless pods.kind_of? Array
                        original_pods = original[config_name] || []
                        original_pods.concat(pods).uniq! 
                        original[config_name] = original_pods
                    end
                end
                # delete key if blank
                if original.empty?
                    t.send(:internal_hash).delete(key)
                end
            end
        end

        def print_podfile_raw_dependencies(target)

            def print_target_def_and_its_dependencies(target_def, intend = "")
                puts "|\n"
                puts "| #{intend}TARGET_DEFINITION: #{target_def}"
                puts "| #{intend}INHIBIT_WARNING: #{target_def.send :raw_inhibit_warnings_hash}"
                puts "| #{intend}DEPS: #{target_def.send :get_hash_value, 'dependencies'}"
                target_def.children.each do |target_def|
                    print_target_def_and_its_dependencies(target_def, intend + "    ")
                end
            end
            print_target_def_and_its_dependencies(target)
        end 
    end
end


# ----- contents of 'fix_module.rb' -------- 

module Pod
    class Podfile
        module DSL
    
            # Cocoapods have a bug: doesn't generate modulemap for pure binary pod 
            # https://code.byted.org/iOS_Library/MobileDev/issues/256
            #
            # This function could fix this bug. 
            # Module if recommanded for swift project, so that you can use import XXX directly
            # 
            def bd_fix_module_for_binary_pod!
                if Pod::VERSION.start_with? "1.4"
                    raise "bd_fix_module_for_binary_pod! doesn't support cocoapods 1.4, use 1.5 or 1.6"
                end
                tmp_path = ENV["TMPDIR"]

                if Pod::VERSION.start_with? "1.5"
                    file_path = Pathname.new(tmp_path) + "bd_fix_module_1_5.rb"
                    File.write(file_path, $BD_fix_module_code_1_5)
                    load file_path.to_s
                    File.delete file_path
                else
                    # 1.6 or above
                    file_path = Pathname.new(tmp_path) + "bd_fix_module_1_6.rb"
                    File.write(file_path, $BD_fix_module_code_1_6)
                    load file_path.to_s
                    File.delete file_path
                end
            end
        end
    end
end



$BD_fix_module_code_1_6 = %q{
# ------ fix for cocoapods 1.6 -------

#
# REASON:
#
# When a pod only have vendored library, and the 'use_modular_header' is on, cocoapods won't
# generate a modulemap (so module is not working), beacause it consider it as "should_build? == false".
#
# It's a bug of cocoapods.
#
# We fix it by changing the `install!` method:
#
#    when a pod is (target.should_build? == true && target.uses_modular_headers?),
#    we treat it differently: like nomarl pods,
#       - create_umbrella_header
#       - create_module_map
#

module Pod
  class PodTarget

    def contain_vendored_libraries_and_no_vendored_frameworks?
      return @uses_libraries_no_frameworks if defined? @uses_libraries_no_frameworks
      @uses_libraries_no_frameworks = begin
        accessors = file_accessors.reject { |a| a.spec.test_specification? }
        !accessors.empty? && accessors.all? do |file_accessor|
          !file_accessor.vendored_libraries.blank? && file_accessor.vendored_frameworks.blank?
        end
      end
    end

    def should_generate_module_map_for_a_pod_should_not_build?
      @should_generate_module_map_for_a_pod_should_not_build ||= begin
        self.uses_modular_headers? && contain_vendored_libraries_and_no_vendored_frameworks?
      end
    end

  end
end

module Pod
  class Installer
    class Xcode
      class PodsProjectGenerator
        class PodTargetInstaller


          FIX_MODULE_OLD_install = instance_method(:install!)
          define_method(:install!) do

              if (not target.should_build?) && target.should_generate_module_map_for_a_pod_should_not_build?
                  # special handling for pod with no source code

                  # Most code below are copied from original install! method
                  native_target = add_target
                  _, file_accessors = target.file_accessors.partition { |fa| fa.spec.test_specification? }
                  resource_bundle_targets = add_resources_bundle_targets(file_accessors).values.flatten
                  create_xcconfig_file(native_target, resource_bundle_targets)

                  if target.defines_module?
                    create_module_map(native_target) do |generator|
                      generator.headers.concat module_map_additional_headers
                    end
                    create_umbrella_header(native_target) do |generator|
                      generator.imports += file_accessors.flat_map do |file_accessor|
                        header_dir = if !target.requires_frameworks? && dir = file_accessor.spec_consumer.header_dir
                                       Pathname.new(dir)
                                     end

                        file_accessor.public_headers.map do |public_header|
                          public_header = if header_mappings_dir
                                            public_header.relative_path_from(header_mappings_dir)
                                          else
                                            public_header.basename
                                          end
                          if header_dir
                            public_header = header_dir.join(public_header)
                          end
                          public_header
                        end
                      end
                    end
                  end

                  if target.requires_frameworks?
                    unless skip_info_plist?(native_target)
                      create_info_plist_file(target.info_plist_path, native_target, target.version, target.platform)
                    end
                    create_build_phase_to_symlink_header_folders(native_target)
                  elsif target.uses_swift?
                    add_swift_static_library_compatibility_header_phase(native_target)
                  end


                  clean_support_files_temp_dir
                  TargetInstallationResult.new(target, native_target, resource_bundle_targets)


              else
                  # call original
                  FIX_MODULE_OLD_install.bind(self).()
              end

          end # patch ended

        end
      end
    end
  end
end



module Pod
  class Target
    # @since 1.5.0
    class BuildSettings

        class PodTargetSettings

              # Patch (because there is a shuld_build? check)
              #
              FIX_MODULE_OLD_module_map_file_to_import = instance_method(:module_map_file_to_import)
              define_method(:module_map_file_to_import) do

                if (not target.should_build?) && target.should_generate_module_map_for_a_pod_should_not_build?
                    # ---- Code bellow is copied form the original method ----
                    #
                    # ---------------- this line is deleted ------------------
                    # return unless target.should_build?
                    # -------------------------------------------------------
                    #
                    return if target.requires_frameworks?
                    return unless target.defines_module?

                    if target.uses_swift?
                      # for swift, we have a custom build phase that copies in the module map, appending the .Swift module
                      "${PODS_CONFIGURATION_BUILD_DIR}/#{target.label}/#{target.product_module_name}.modulemap"
                    else
                      "${PODS_ROOT}/#{target.module_map_path.relative_path_from(target.sandbox.root)}"
                    end
                    # ---- Code above is copied form the original method ----
                else
                    # call original
                    FIX_MODULE_OLD_module_map_file_to_import.bind(self).()
                end

              end # patch ended

        end

    end
  end
end


# ------ \fix for cocoapods 1.6 -------
}

$BD_fix_module_code_1_5 = %q{
# ------ fix for cocoapods 1.5 ------- 

#
# REASON:
#
# When a pod only have vendored library, and the 'use_modular_header' is on, cocoapods won't
# generate a modulemap (so module is not working), beacause it consider it as "should_build? == false".
#
# It's a bug of cocoapods.
#
# We fix it by changing the `install!` method:
#
#    when a pod is (target.should_build? == true && target.uses_modular_headers?),
#    we treat it differently: like nomarl pods,
#       - create_umbrella_header
#       - create_module_map

module Pod
  class PodTarget

    def contain_vendored_libraries_and_no_vendored_frameworks?
      return @uses_libraries_no_frameworks if defined? @uses_libraries_no_frameworks
      @uses_libraries_no_frameworks = begin
        accessors = file_accessors.reject { |a| a.spec.test_specification? }
        !accessors.empty? && accessors.all? do |file_accessor|
          !file_accessor.vendored_libraries.blank? && file_accessor.vendored_frameworks.blank?
        end
      end
    end

    def should_generate_module_map_for_a_pod_should_not_build?
      @should_generate_module_map_for_a_pod_should_not_build ||= begin
        self.uses_modular_headers? && contain_vendored_libraries_and_no_vendored_frameworks?
      end
    end

  end
end


module Pod
  class Installer
    class Xcode
      class PodsProjectGenerator
        class PodTargetInstaller


          FIX_MODULE_OLD_install = instance_method(:install!)
          define_method(:install!) do

              if (not target.should_build?) && target.should_generate_module_map_for_a_pod_should_not_build?
                  # special handling for pod with no source code

                  # Most code below are copied from original install! method
                  # Manually checked the 1.5.3/ 1.5.2/ 1.5.1/ 1.5.0, they are all the same. So it's safe.
                  UI.message "- Installing target `#{target.name}` #{target.platform}" do
                    add_target
                    create_support_files_dir

                    add_resources_bundle_targets
                    create_xcconfig_file

                    if target.defines_module?
                      create_module_map do |generator|
                        generator.headers.concat module_map_additional_headers
                      end
                      create_umbrella_header do |generator|
                        file_accessors = target.file_accessors
                        file_accessors = file_accessors.reject { |f| f.spec.test_specification? } if target.contains_test_specifications?
                        generator.imports += if header_mappings_dir
                                               file_accessors.flat_map(&:public_headers).map do |pathname|
                                                 pathname.relative_path_from(header_mappings_dir)
                                               end
                                             else
                                               file_accessors.flat_map(&:public_headers).map(&:basename)
                                             end
                      end
                    end

                    if target.requires_frameworks?
                      unless target.static_framework?
                        create_info_plist_file(target.info_plist_path, native_target, target.version, target.platform)
                      end
                      create_build_phase_to_symlink_header_folders
                    elsif target.uses_swift?
                      add_swift_static_library_compatibility_header_phase
                    end

                  end

              else
                  # call original
                  FIX_MODULE_OLD_install.bind(self).()
              end

          end # patch ended


        end
      end
    end
  end
end





module Pod
  class Installer
    class Xcode
      class PodsProjectGenerator


            # override
            #
            # Manually checked the 1.5.3/ 1.5.2/ 1.5.1/ 1.5.0, they are all the same. So it's safe.
            #
            def install_libraries
              UI.message '- Installing targets' do
                umbrella_headers_by_dir = pod_targets.map do |pod_target|
                  ## ---- modified
                  # next unless pod_target.should_build? && pod_target.defines_module?
                  next unless pod_target.defines_module?
                  next unless (pod_target.should_build? || pod_target.should_generate_module_map_for_a_pod_should_not_build? )
                  ## ---- modifed end
                  #
                  # contentx below is copied from original method

                  pod_target.umbrella_header_path
                end.compact.group_by(&:dirname)

                pod_targets.sort_by(&:name).each do |pod_target|
                  target_installer = PodTargetInstaller.new(sandbox, pod_target)
                  target_installer.umbrella_headers_by_dir = umbrella_headers_by_dir
                  target_installer.install!
                end

                aggregate_targets.sort_by(&:name).each do |target|
                  target_installer = AggregateTargetInstaller.new(sandbox, target)
                  target_installer.install!
                end

                add_system_framework_dependencies
              end
            end

      end
    end
  end
end



module Pod
  module Generator
    module XCConfig
      module XCConfigHelper

              # override
              #
              # Manually checked the 1.5.3/ 1.5.2/ 1.5.1, they are all the same. So it's safe.
              # 1.5.0 is slightly different at Line 147 (`dependent_targets.uniq.combination(2) do |a, b|`)
              # with no `uniq`, but I think it's not a problem.
              #
              def self.search_paths_for_dependent_targets(target, dependent_targets, test_xcconfig = false)
                ## ---- modified
                # dependent_targets = dependent_targets.select(&:should_build?)
                dependent_targets = dependent_targets.select { |target| target.should_build? || target.should_generate_module_map_for_a_pod_should_not_build? }
                ## ---- modifed end
                #
                # contentx below is copied from original method

                # Filter out dependent targets that are subsets of another target.
                subset_targets = []
                dependent_targets.uniq.combination(2) do |a, b|
                  if (a.specs - b.specs).empty?
                    subset_targets << a
                  elsif (b.specs - a.specs).empty?
                    subset_targets << b
                  end
                end
                dependent_targets -= subset_targets

                # Alias build dirs to avoid recursive definitions for pod targets and depending
                # on build settings which could be overwritten in the user target.
                build_settings = {
                    BUILD_DIR_VARIABLE[2..-2] => '${BUILD_DIR}',
                    CONFIGURATION_BUILD_DIR_VARIABLE[2..-2] => "#{BUILD_DIR_VARIABLE}/$(CONFIGURATION)$(EFFECTIVE_PLATFORM_NAME)",
                }

                # Scope pod targets as long as they are not test targets.
                if !test_xcconfig && target.respond_to?(:configuration_build_dir)
                  build_settings['CONFIGURATION_BUILD_DIR'] = target.configuration_build_dir(CONFIGURATION_BUILD_DIR_VARIABLE)
                end

                module_map_files = []
                unless dependent_targets.empty?
                  framework_search_paths = []
                  library_search_paths = []
                  swift_import_paths = []
                  dependent_targets.each do |dependent_target|
                    if dependent_target.requires_frameworks?
                      framework_search_paths << dependent_target.configuration_build_dir(CONFIGURATION_BUILD_DIR_VARIABLE)
                    else
                      ### -------------- modified ---------------
                      # library_search_paths << dependent_target.configuration_build_dir(CONFIGURATION_BUILD_DIR_VARIABLE)
                      # --- to ----
                      if dependent_target.should_build?
                        library_search_paths << dependent_target.configuration_build_dir(CONFIGURATION_BUILD_DIR_VARIABLE)
                      end
                      ### -------------- \modified ---------------
                      if dependent_target.defines_module?
                        module_map_file = if dependent_target.uses_swift?
                                            # for swift, we have a custom build phase that copies in the module map, appending the .Swift module
                                            "${PODS_CONFIGURATION_BUILD_DIR}/#{dependent_target.label}/#{dependent_target.product_module_name}.modulemap"
                                          else
                                            "${PODS_ROOT}/#{dependent_target.module_map_path.relative_path_from(dependent_target.sandbox.root)}"
                                          end
                        module_map_files << %(-fmodule-map-file="#{module_map_file}")
                        swift_import_paths << dependent_target.configuration_build_dir(CONFIGURATION_BUILD_DIR_VARIABLE) if dependent_target.uses_swift?
                      end
                    end
                  end
                  build_settings['FRAMEWORK_SEARCH_PATHS'] = XCConfigHelper.quote(framework_search_paths.uniq)
                  build_settings['LIBRARY_SEARCH_PATHS']   = XCConfigHelper.quote(library_search_paths.uniq)
                  build_settings['SWIFT_INCLUDE_PATHS']    = XCConfigHelper.quote(swift_import_paths.uniq)
                end

                other_swift_flags = module_map_files.tap(&:uniq!).flat_map { |f| ['-Xcc', f] }
                if target.is_a?(PodTarget) && !target.requires_frameworks? && target.defines_module? && !test_xcconfig
                  # make it possible for a mixed swift/objc static library to be able to import the objc from within swift
                  other_swift_flags += ['-import-underlying-module', '-Xcc', '-fmodule-map-file="${SRCROOT}/${MODULEMAP_FILE}"']
                end
                # unconditionally set these, because of (the possibility of) having to add the pod targets own module map file
                build_settings['OTHER_CFLAGS']           = module_map_files.join(' ')
                build_settings['OTHER_SWIFT_FLAGS']      = other_swift_flags.join(' ')

                build_settings
              end
      end
    end
  end
end

# ------ \fix for cocoapods 1.5 ------- 
}  # the root level string
# This file is generated automatically. DO NOT EDIT MANUALLY!
