require 'cocoapods-core'
require 'json'
require 'pp'
require 'open-uri'
require 'net/http'

class BDIntegrate
  def self.load_file(file_path)
    if File::file?(file_path)
      @@config = Pod::YAMLHelper.load_file(file_path)
      self.get_response(self.generateUrl)
    end
  end

  def self.get_response(url)
    
    begin
      url_str = URI.parse(url)
      $origin = File.dirname(__FILE__)
      response = Net::HTTP.get_response(url_str)
      body = response.body
      status = response.code
      raise '网络请求出错误,使用本地版本' unless status == '200'
      @@podfile_json = JSON.parse(body)
      
      self.generatePodfile_Map
    rescue Exception => ex
      p ex
    end
  end

  def self.generateUrl
    url = "http://tosv.byted.org/obj/iosbinary/integrate/#{@@config['integrateID']}/#{@@config['developItemID']}/#{@@config['itemHistoryID']}/component.json"
  end

  def self.generatePodfile_Map
    podfile = "
# owner:#{@@podfile_json['owner'].to_s}
# BM:#{@@podfile_json['BM']}
    "
    @@podfile_json['projects'].each do |project|
      podfile = podfile + "\n" + "
target \'#{project['name']}\' do
      "
      project['components'].each do |component|
        podfile = podfile + "
  pod \'#{component['name']}\',\'#{component['version']}\'"
        if component['subspecs']
          podfile = podfile + ",:subspecs=>[\n"
                component = component['subspecs'].map { |sub| "\'#{sub}\'"}
          subspec_des = component.join(sep=",\n   ")
          podfile = podfile + "   " + subspec_des + "\n  ]"
        end
        
      end
      podfile = podfile + "\n" + "end"
    end
    system('rm -rf Podfile_Map')
    aFile = File.new("Podfile_Map", "a+")
    if aFile
      aFile.syswrite(podfile)
    end
  end

end

if ARGV.length
  BDIntegrate.load_file(ARGV.first)
end
